<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/anyhow-1.0.58/src/kind.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>kind.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../anyhow/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
</pre><pre class="rust"><code><span class="comment">// Tagged dispatch mechanism for resolving the behavior of `anyhow!($expr)`.</span>
<span class="comment">//</span>
<span class="comment">// When anyhow! is given a single expr argument to turn into anyhow::Error, we</span>
<span class="comment">// want the resulting Error to pick up the input&#39;s implementation of source()</span>
<span class="comment">// and backtrace() if it has a std::error::Error impl, otherwise require nothing</span>
<span class="comment">// more than Display and Debug.</span>
<span class="comment">//</span>
<span class="comment">// Expressed in terms of specialization, we want something like:</span>
<span class="comment">//</span>
<span class="comment">//     trait AnyhowNew {</span>
<span class="comment">//         fn new(self) -&gt; Error;</span>
<span class="comment">//     }</span>
<span class="comment">//</span>
<span class="comment">//     impl&lt;T&gt; AnyhowNew for T</span>
<span class="comment">//     where</span>
<span class="comment">//         T: Display + Debug + Send + Sync + &#39;static,</span>
<span class="comment">//     {</span>
<span class="comment">//         default fn new(self) -&gt; Error {</span>
<span class="comment">//             /* no std error impl */</span>
<span class="comment">//         }</span>
<span class="comment">//     }</span>
<span class="comment">//</span>
<span class="comment">//     impl&lt;T&gt; AnyhowNew for T</span>
<span class="comment">//     where</span>
<span class="comment">//         T: std::error::Error + Send + Sync + &#39;static,</span>
<span class="comment">//     {</span>
<span class="comment">//         fn new(self) -&gt; Error {</span>
<span class="comment">//             /* use std error&#39;s source() and backtrace() */</span>
<span class="comment">//         }</span>
<span class="comment">//     }</span>
<span class="comment">//</span>
<span class="comment">// Since specialization is not stable yet, instead we rely on autoref behavior</span>
<span class="comment">// of method resolution to perform tagged dispatch. Here we have two traits</span>
<span class="comment">// AdhocKind and TraitKind that both have an anyhow_kind() method. AdhocKind is</span>
<span class="comment">// implemented whether or not the caller&#39;s type has a std error impl, while</span>
<span class="comment">// TraitKind is implemented only when a std error impl does exist. The ambiguity</span>
<span class="comment">// is resolved by AdhocKind requiring an extra autoref so that it has lower</span>
<span class="comment">// precedence.</span>
<span class="comment">//</span>
<span class="comment">// The anyhow! macro will set up the call in this form:</span>
<span class="comment">//</span>
<span class="comment">//     #[allow(unused_imports)]</span>
<span class="comment">//     use $crate::private::{AdhocKind, TraitKind};</span>
<span class="comment">//     let error = $msg;</span>
<span class="comment">//     (&amp;error).anyhow_kind().new(error)</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Error</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="ident">Debug</span>, <span class="ident">Display</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::StdError</span>;

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Adhoc</span>;

<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">AdhocKind</span>: <span class="ident">Sized</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">anyhow_kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Adhoc</span> {
        <span class="ident">Adhoc</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">AdhocKind</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">T</span> <span class="kw">where</span> <span class="ident">T</span>: <span class="question-mark">?</span><span class="ident">Sized</span> <span class="op">+</span> <span class="ident">Display</span> <span class="op">+</span> <span class="ident">Debug</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span> {}

<span class="kw">impl</span> <span class="ident">Adhoc</span> {
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span><span class="op">&lt;</span><span class="ident">M</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">message</span>: <span class="ident">M</span>) -&gt; <span class="ident">Error</span>
    <span class="kw">where</span>
        <span class="ident">M</span>: <span class="ident">Display</span> <span class="op">+</span> <span class="ident">Debug</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>,
    {
        <span class="ident">Error::from_adhoc</span>(<span class="ident">message</span>, <span class="macro">backtrace!</span>())
    }
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Trait</span>;

<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">TraitKind</span>: <span class="ident">Sized</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">anyhow_kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Trait</span> {
        <span class="ident">Trait</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span> <span class="ident">TraitKind</span> <span class="kw">for</span> <span class="ident">E</span> <span class="kw">where</span> <span class="ident">E</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">Error</span><span class="op">&gt;</span> {}

<span class="kw">impl</span> <span class="ident">Trait</span> {
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="ident">E</span>) -&gt; <span class="ident">Error</span>
    <span class="kw">where</span>
        <span class="ident">E</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">Error</span><span class="op">&gt;</span>,
    {
        <span class="ident">error</span>.<span class="ident">into</span>()
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Boxed</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">BoxedKind</span>: <span class="ident">Sized</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">anyhow_kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Boxed</span> {
        <span class="ident">Boxed</span>
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">BoxedKind</span> <span class="kw">for</span> <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">StdError</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span><span class="op">&gt;</span> {}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">Boxed</span> {
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">StdError</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span><span class="op">&gt;</span>) -&gt; <span class="ident">Error</span> {
        <span class="kw">let</span> <span class="ident">backtrace</span> <span class="op">=</span> <span class="macro">backtrace_if_absent!</span>(<span class="ident">error</span>);
        <span class="ident">Error::from_boxed</span>(<span class="ident">error</span>, <span class="ident">backtrace</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="anyhow" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>